<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="utf-8">
    <title>JSDoc: Source: modules/productsModule.js</title>

    <script src="scripts/prettify/prettify.js"> </script>
    <script src="scripts/prettify/lang-css.js"> </script>
    <!--[if lt IE 9]>
      <script src="//html5shiv.googlecode.com/svn/trunk/html5.js"></script>
    <![endif]-->
    <link type="text/css" rel="stylesheet" href="styles/prettify-tomorrow.css">
    <link type="text/css" rel="stylesheet" href="styles/jsdoc-default.css">
</head>

<body>

<div id="main">

    <h1 class="page-title">Source: modules/productsModule.js</h1>

    



    
    <section>
        <article>
            <pre class="prettyprint source linenums"><code>let referenceToThis = null;

/**
 * This function is responsible to set a tradeshow
 *
 * @param {object} params - Object with key equivalent to a column of the table and value equivalent to the value or array of
 * value you want to filter
 * @returns {Promise} Returns a new Promise object.
 */
const filter = (params = {}) => {
  const keys = Object.keys(params);

  return new Promise((resolve, reject) => {
    referenceToThis.products
      .get()
      .then((result) => {
        const filteredResult = result.resource.filter((item) => {
          let verify = true;
          keys.forEach((key) => {
            if (verify) {
              if (typeof params[key] === 'object') {
                verify = params[key].includes(item[key]);
              } else {
                verify = params[key] === item[key];
              }
            }
          });

          return verify;
        });
        result.resource = filteredResult;

        return resolve(result);
      })
      .catch((error) => {
        return reject(error);
      });
  });
};

const productsModule = (thisObject) => {
  referenceToThis = thisObject;
  referenceToThis.products.filter = filter;
};

export default productsModule;
</code></pre>
        </article>
    </section>




</div>

<nav>
    <h2><a href="index.html">Home</a></h2><h3>Classes</h3><ul><li><a href="MagentoClient.html">MagentoClient</a></li><li><a href="MagentoClient_MagentoClient.html">MagentoClient</a></li><li><a href="MagentoConnection.html">MagentoConnection</a></li></ul><h3>Global</h3><ul><li><a href="global.html#connection">connection</a></li><li><a href="global.html#filter">filter</a></li></ul>
</nav>

<br class="clear">

<footer>
    Documentation generated by <a href="https://github.com/jsdoc/jsdoc">JSDoc 3.6.3</a> on Fri Feb 07 2020 12:43:27 GMT-0500 (Eastern Standard Time)
</footer>

<script> prettyPrint(); </script>
<script src="scripts/linenumber.js"> </script>
</body>
</html>
